C  Program: snow_syn.f
C  Author: Peter Romanov
C  Last update: Jan. 16, 2002
C  
C  This program does the sorting of surface snow observations
C
C*********************************************

      CHARACTER*7 BUFFER
      CHARACTER*5 ADATE
      CHARACTER*12 STLIST 
      CHARACTER*9 FILSYN, FILCOP, FILMET, FILSRF
      LOGICAL EXST
      DIMENSION XLAT(2500), XLON(2500), IXSN(2500), IXEL(2500)
      DIMENSION ALON(2500), ALAT(2500), IASN(2500), IAEL(2500)
      DIMENSION  IXSD(2500)
      DIMENSION  ITYPE(2500)
      DATA FILSYN /'SYX._____'/
      DATA FILCOP /'DEP._____'/
      DATA FILMET /'MET._____'/
      DATA FILSRF /'SRF._____'/
      DATA STLIST /'syn_stat.dat'/
      NSTSYN=0
      NSTCOP=0
      NTOT=0

C ============ READ =====================
      OPEN (9,FILE='sdate.dat',ACCESS='SEQUENTIAL',FORM='FORMATTED')
      READ (9,1000) IDATE
 1000 FORMAT (I7)
      CLOSE (9)
      WRITE (*,1230) IDATE
 1230 FORMAT ('PROCESSING DATE: ',I7)
      IYEAR=IDATE/1000
      IDAY=IDATE-IYEAR*1000
      WRITE (BUFFER, 1000) IDATE
      READ (BUFFER,1010) ADATE 
 1010 FORMAT (2X,A5)
      FILSYN(5:9)=ADATE
      FILCOP(5:9)=ADATE
      FILMET(5:9)=ADATE
      FILSRF(5:9)=ADATE
      WRITE (*,1020) FILSYN, FILCOP, FILMET
 1020 FORMAT ('FILE NAMES:   ', A9/14X,A9/14X,A9)
      WRITE (*,1430) FILSRF
 1430 FORMAT ('OUTPUT FILE:  ', A9)

c ================================================================= 
c     will check, if all files exist
c =================================================================
        ISYN=1
        INQUIRE (FILE=FILSYN,EXIST=EXST) 
        IF (.NOT.EXST) THEN
          WRITE (*,1030) 
 1030     FORMAT (1X,' NO SYNOP DATA FILE FOUND ')
          ISYN=0
        ENDIF
        IMET=1
        INQUIRE (FILE=FILMET,EXIST=EXST) 
        IF (.NOT.EXST) THEN
          WRITE (*,1330) 
 1330     FORMAT (1X,' NO METAR DATA FILE FOUND ')
          IMET=0
        ENDIF
        ICOP=1
        INQUIRE (FILE=FILCOP,EXIST=EXST) 
        IF (.NOT.EXST) THEN
          WRITE (*,1040) 
 1040     FORMAT (1X,' NO COOP DATA FILE FOUND ')
          ICOP=0
        ENDIF
        IF (ICOP.EQ.0.AND.ISYN.EQ.0) GO TO 50    ! NO GROUND DATA FILES FOUND

C ======= READING LOCATIONS OF FIRST-ORDER STATIONS REPORTING SNOW ======== 
c         OPEN (11,FILE='syn_stat.dat',ACCESS='SEQUENTIAL',
c     *            FORM='FORMATTED')
c         NN=0
c         DO IOBS=1,300
c           READ (11,1290,END=40) IOBS,SLAT(IOBS),SLON(IOBS)
c 1290      FORMAT (I4,2F7.2)
c           NN=NN+1
c         ENDDO
c   40    CONTINUE
c         CLOSE (11)

C ================================================================
C  NOW WILL SORT OUT SYNOP DATA
C  ONLY STATIONS REPORTING SNOW DEPTH ARE SELECTED
C ================================================================
        IPT=0
        IF (ISYN.EQ.1) THEN
          OPEN (12,FILE=FILSYN, ACCESS='SEQUENTIAL',
     *           FORM='FORMATTED')
          DO I=1,2
            READ  (12,1070,END=10,ERR=10) 
 1070       FORMAT ()
          ENDDO
          WRITE (*,1080)
 1080     FORMAT ('READING SYNOP FILE')
          DO I=1,3000
            READ (12,1090,END=10,ERR=10) VLAT,VLON, IDAY, ITIME, 
     *                         TEMP, ISNOW, IELEV
 1090       FORMAT (F7.2,F8.2,I8,I7,F7.1,I5,11X,I6)
            KKK=0
C            DO K=1,NN
C               IF (SLAT(K).EQ.VLAT.AND.SLON(K).EQ.VLON) KKK=1
C            ENDDO
            IF (ISNOW.GE.0) THEN
              IPT=IPT+1    
              XLAT(IPT)=VLAT
              XLON(IPT)=VLON
              IXSN(IPT)=ISNOW
              IXEL(IPT)=IELEV
            ENDIF
          ENDDO
          CLOSE (12)
   10     CONTINUE
        ENDIF
        IF (IMET.EQ.1) THEN
          OPEN (12,FILE=FILMET, ACCESS='SEQUENTIAL',
     *           FORM='FORMATTED')
          DO I=1,2
            READ  (12,1070,ERR=60,END=60) 
          ENDDO
          WRITE (*,1380)
 1380     FORMAT ('READING METAR FILE')
          DO I=1,3000
            READ (12,1390,END=60,ERR=60) VLAT,VLON, IDAY, ITIME, 
     *                         TEMP, ISNOW, IELEV
 1390       FORMAT (F7.2,F8.2,I8,I7,F7.1,I5,I7)
            IF (ISNOW.GE.0) THEN
              IPT=IPT+1    
              XLAT(IPT)=VLAT
              XLON(IPT)=VLON
              IXSN(IPT)=ISNOW
              IXEL(IPT)=IELEV
            ENDIF
          ENDDO
          CLOSE (12)
   60     CONTINUE
        ENDIF
        NPT=IPT
        IF (IPT.NE.0) THEN 
          NST=1
          ALON(1)=XLON(1)
          ALAT(1)=XLAT(1)
          IASN(1)=IXSN(1)
          IAEL(1)=IXEL(1)
          DO IPT=2,NPT
            INEW=1
            DO IST=1,NST
              IF (ALON(IST).EQ.XLON(IPT).AND.
     *           ALON(IST).EQ.XLON(IPT)) THEN
                  INEW=0
                  IF (IXSN(IPT).GT.IASN(IST)) IASN(IST)=IXSN(IPT)
              ENDIF
            ENDDO
            IF (INEW.EQ.1) THEN
              NST=NST+1
              ALON(NST)=XLON(IPT)
              ALAT(NST)=XLAT(IPT)
              IASN(NST)=IXSN(IPT)
              IAEL(NST)=IXEL(IPT)
            ENDIF
          ENDDO
          CLOSE (12)
          NSTSSS=NST
          DO IST=1,NSTSSS
             ITYPE(IST)=1
          ENDDO
          WRITE (*,1100) NSTSSS
 1100     FORMAT ('N FIRST-ORDER AND METAR STATION SNOW REPORTS: ',I5)

c         DO IST=1,NST
c           WRITE (*,1110) ALAT(IST), ALON(IST),IASN(IST),IAEL(IST)
c 1110      FORMAT (2F7.2,2I6)
c         ENDDO 
        ENDIF
C ==========================================================
C
C   NOW READING COOP STATIONS DATA 
C
C ========================================================== 
        NSTCOP=0
        IF (ICOP.EQ.1) THEN 
          OPEN (10,FILE=FILCOP,ACCESS='SEQUENTIAL',
     *        FORM='FORMATTED')
          DO IR=1,3
            READ (10,1200) 
 1200       FORMAT ()
          ENDDO
          IST=0
            DO IR=1,1200
            READ (10,1120,END=90) VLAT, VLON, ISDEP
 1120       FORMAT (F6.2, F8.2,I4)
            BACKSPACE (10)
            READ (10,1130,ERR=20) ISEL
 1130       FORMAT (59X,I4)
            GO TO 30
   20       ISEL=0
   30       CONTINUE
            IST=IST+1
            XLON(IST)=VLON
            XLAT(IST)=VLAT
            IXSD(IST)=ISDEP*2.54           ! depth in cm
            IXEL(IST)=FLOAT(ISEL)*0.3048   ! height in meters
          ENDDO
   90     CONTINUE
          CLOSE (10)
          NSTCOP=IST
          WRITE (*,1140) NSTCOP
 1140     FORMAT ('COOP STATIONS REPORTS READ: ', I5)
          DO IST=1,NSTCOP
            ALAT(IST+NSTSSS)=XLAT(IST)
            ALON(IST+NSTSSS)=XLON(IST)
            IASN(IST+NSTSSS)=IXSD(IST)
            IAEL(IST+NSTSSS)=IXEL(IST)
            ITYPE(IST+NSTSSS)=2
          ENDDO
        ENDIF
        NTOT=NSTSSS+NSTCOP
        WRITE (*,1150) NTOT
 1150   FORMAT ('TOTAL SNOW REPORTS: ',I5)      
   50   CONTINUE 
        OPEN (4,FILE=FILSRF,ACCESS='SEQUENTIAL',
     *        FORM='FORMATTED')
        WRITE (4,1050) IDATE, NTOT, NSTSSS,NSTCOP
 1050   FORMAT (I7,3X,3I5)
        DO I=1,NTOT
          WRITE (4,1060) ALAT(I),ALON(I),IASN(I),IAEL(I),ITYPE(I)
 1060     FORMAT (2F8.2, 3I7)
        ENDDO
        CLOSE (4)
      END
