C
C      SLAT=55      ! OBS LAT
C      SLON=90    ! OBS LON
C      PLAT=55      ! SAT LAT
C      PLON=100    ! SAT LON
C      SOLLAT=20     ! SOL LAT
C      SOLLON=100  ! SOL LON
C      CALL AZM (SLAT,SLON,PLAT,PLON, SOLLON, SOLLAT,
C     *                    SOLZAN, AZMT)
C      WRITE (*,1000) SLAT,SLON,PLAT,PLON, SOLLON,SOLLAT,
C     *               SOLZAN,AZMT
C 1000 FORMAT (2X,10F7.1)
C      END
C**********************************************************************
      SUBROUTINE AZM (SLAT,SLON,PLAT,PLON, SOLLNT, SOLLTD,
     *                    SOLZAN, AZMT)
      DATA  DTR/0.017453293D0/, RTD/57.29577951D0/
C------------------------------------------------------------------
c     0.0 deg azimuth corresponds to exact forward scatter (?)
c     for GOES the convention is different (0 deg azimuth corresponds
c     to exact backscatter)
c -----------------------------------------------------------------
      AZMT = 0.0
C...CONVERT DEGREE VALUES TO RADIANS
      RAD1 = DTR*SLAT     ! OBSERVATION POINT
      RAD2 = DTR*SLON     ! OBSERVATION POINT
      SSP1 = DTR*PLAT   ! SUBSATELLITE POINT
      SSP2 = DTR*PLON   ! SUBSATELLITE POINT
      SOLLON = DTR*SOLLNT
      SOLLAT = DTR*SOLLTD
      THEA1 = SIN(SOLLAT)*SIN(SSP1)+COS(SOLLAT)*
     *        COS(SSP1)*COS(SOLLON-SSP2)
      THEA2 = SIN(SOLLAT)*SIN(RAD1)+COS(SOLLAT)*
     *        COS(RAD1)*COS(SOLLON-RAD2)
      THEA3 = SIN(SSP1)*SIN(RAD1)+COS(SSP1)*
     *        COS(RAD1)*COS(RAD2-SSP2)
      IF ((THEA3 .GT. 1.00) .OR. (THEA3 .LT. -1.00)) GO TO 1000
      IF ((THEA1 .GT. 1.00) .OR. (THEA1 .LT. -1.00)) GO TO 1000
      IF ((THEA2 .GT. 1.00) .OR. (THEA2 .LT. -1.00)) GO TO 1000
C...ZENITH ANGLE AT THE POINT OF OBSERVATION
      THEA22 = ACOS(THEA2)
C...CONVERT SOLAR ZENITH FROM RADIANS TO DEGREES
      SOLZAN = RTD * THEA22
      THEA33 = ACOS(THEA3)
      IF (THEA33 .LE. 0.001) GO TO 1000
      THEA  = THEA3*THEA2 - THEA1
      CHI   = THEA /(SIN(THEA33)*SIN(THEA22))
      IF (CHI .GT. 1.00) THEN
         CHI = 1.00
      ELSE IF (CHI .LT.-1.00) THEN
         CHI = -1.00
      ENDIF
C...RELATIVE AZMIUTH IN RADIANS
      AZMUTH = ACOS(CHI)
      AZMT = RTD * AZMUTH
 1000 RETURN
      END
