      SUBROUTINE TRANS(OPTION,AREA,ARADIR,AL,AE,XLAT,XLON,
     &                                IFLAG,ERROR,INEW)
C
      IMPLICIT CHARACTER*12 (C)
      IMPLICIT REAL*8       (D)
 
      CHARACTER*2            OPTION
      CHARACTER*80           DMSG
 
      REAL             X,Y,XLAT,XLON,XDUM
 
      INTEGER AREA,ARADIR(64),ERROR,FIRST
      INTEGER AL,AE
 
      LOGICAL DBUG,DIAG
 
      COMMON/DEBUG/DBUG,DIAG
      COMMON /CONV/ IDXLN,IDXEL
      ERROR = 0
      DMSG = ' '
C
      IF(OPTION.NE.'AE'.AND.OPTION.NE.'EA') THEN
         ERROR = 1
         CALL SDEST('(TRANS) ERROR: OPTION MUST BE EITHER AE OR EA',0)
         RETURN
      ENDIF

      IF(INEW.EQ.0) THEN
C
C        Initialize navigation information
C
         INVSET = NVSET('AREA',AREA)
         IF(INVSET.NE.0) THEN
             ERROR = INVSET
             DMSG='(TRANS) ERROR: CANNOT SET NAVIGATION FOR AREA:    '//
     *       ' NVSET ERROR = '
             WRITE(DMSG(47:50),'(I4)',IOSTAT=IOS) AREA
             WRITE(DMSG(65:68),'(I4)',IOSTAT=IOS) ERROR 
             CALL SDEST(DMSG,0)
             RETURN
         ENDIF
         IF(DBUG.OR.DIAG) THEN
             DMSG='(TRANS) NAVIGATION HAS BEEN INITIALIZED '//
     *       'VIA FUNCTION NVSET...'
             CALL SDEST(DMSG,0)
         ENDIF
      ENDIF
      IF (OPTION.EQ.'AE') THEN
         IF(DBUG) THEN
C            CALL SDEST('(TRANS)ALIN,AELE='//CFI(AL)//' '//CFI(AE),0)
         ENDIF
C
C        Calculate image coordinates from input area coordinates.
C
C        ARADIR(6) = Y-COOR of upper left line in satellite coordinates
C        ARADIR(7) = X-COOR of upper left element in satellite coordinates
C        ARADIR(12)= Y-RES, line resolution of area
C        ARADIR(13)= X-RES, element resolution of area
C
         X = FLOAT( ARADIR(6) + AL*ARADIR(12) )
         Y = FLOAT( ARADIR(7) + AE*ARADIR(13) )
         IF(DBUG) THEN
C            CALL SDEST('(TRANS)ILIN,IELE='//CFG(X)//' '//CFG(Y),0)
         ENDIF
C
C        Calculate earth coordinates from image coordinates.
C
         KSTAT=NV1SAE(X,Y,0.,XLAT,XLON,XZ)
         IF(KSTAT.NE.0) THEN
            IFLAG = -1
            ERROR = KSTAT 
C            CALL SDEST('(TRANS) ERROR FROM NV1SAE = ',ERROR)
C            CALL SDEST('        NO NAV FOR AREA = ',AREA)
            RETURN
         ELSE IF(DBUG) THEN
C           CALL SDEST('(TRANS) LAT,LON='//CFG(XLAT)//' '//CFG(XLON),0)
         ENDIF
      ELSE IF (OPTION.EQ.'EA') THEN
         IF(DBUG) THEN
            CALL SDEST('(TRANS) LAT,LON='//CFG(XLAT)//' '//CFG(XLON),0)
         ENDIF
C
C        Calculate image coordinates from earth coordinates.
C
         KSTAT=NV1EAS(XLAT,XLON,0.,XLN,XEL,XDUM)  ! XLN: LINE NUM, XEL: ELEMENT NUM
         IF(KSTAT.NE.0) THEN
            ERROR = KSTAT 
            IFLAG = -1
C            CALL SDEST('(TRANS) ERROR FROM NV1EAS = ',KSTAT)
C            CALL SDEST('        NO NAV FOR AREA = ',AREA)
            RETURN
         ELSE IF(DBUG) THEN
            CALL SDEST('(TRANS)ILIN,IELE='//CFG(X)//' '//CFG(Y),0)
         ENDIF
C
C        Calculate area coordinates from image coordinates.
C        
C        ARADIR(6) = LINE NUM of upper left line in satellite coordinates
C        ARADIR(7) = ELEM NUM of upper left element in satellite coordinates
C        ARADIR(12)= line resolution of area
C        ARADIR(13)= element resolution of area
C
         ISEL=ARADIR(7)
         ISLN=ARADIR(6)
         IDLN=ARADIR(12)
         IDEL=ARADIR(13)
         AL = NINT((XLN - REAL(ISLN))/REAL(IDLN)+0.0)       
         AE = NINT((XEL - REAL(ISEL))/REAL(IDEL)+0.0)   
         NLN=NINT(XLN/4.)*4   ! 4 KM INDICES
         NEL=NINT(XEL/4.)*4
         IDXLN=NLN-ISLN ! 4 KM INDICES IN THE FRAGMENT
         IDXEL=NEL-ISEL
         WRITE (*,1000) XLAT,XLON,XLN,XEL,ISLN,ISEL,AL,AE,
     *          NLN,NEL,IDLN,IDEL,IDXLN,IDXEL
 1000    FORMAT (4F10.2,10I7)
      ENDIF
      RETURN
      END
