      SUBROUTINE LONGCOR (VLON,NCOL)
C
C CORRECT LONGTITUDE VALUES FOR ERRORS CLOSE TO 0 DEG LONGITUDE
C
C FOR SOME REASON MCIDAS PRODUCES WRONG LONGITUDE VALUES FOR THESE PIXELS
C ERRORS ARE IDENTIFIED BY LARGE LONGTITUDE DIFFERENCE BETWEEN PIXELS NEXT TO EACH OTHER
C INCORRECT LONGTUDE VALUES ARE REPLACED WITH INTERPOLATED VALUES
C IF INCORRECT SECTION OF THE STRING IS CLOSE TO THE EDGE OF THE STRING, LABEL ALL 
C INCORRECT LONGITUDES AS UNDETERMINED (=9999.)
C
C
C  VLON: STRING OF LONGITUDE VALUES
C  NCOL: NUMBER OF VALUES IN THE STRING
C

      DIMENSION VLON(NCOL), DLON(NCOL), KCOL(NCOL)

C
C DETERMINE PAIRS WITH LARGE DIFFERENCE IN LONGITUDE (OVER 0.5 DEG)
C LABEL LONGITUDES OF BOTH PIXELS AS QUESTIONABLE
C

      NER=0         ! NUMBER OF ERRORS
      KCMIN=100000
      KCMAX=-10
      DO ICOL=1,NCOL-1
              XLON1=VLON(ICOL)
              XLON2=VLON(ICOL+1)
              DLON(ICOL)=XLON2-XLON1
              IF (ABS(DLON(ICOL)).GT.5.AND.
     *            ABS(DLON(ICOL)).LT.355.AND.
     *            XLON1.LE.180.AND.      !  LONGITUDE VALUES ARE WITHIN -180 TO 180 DEG
     *            XLON2.LE.180) THEN 
                   NER=NER+1
                   KCOL(NER)=ICOL
                   IF (ICOL.LT.KCMIN) KCMIN=ICOL
                   ICL=ICOL+1
                   IF (ICL.GT.KCMAX) KCMAX=ICL
              ENDIF
      ENDDO

      IF (NER.EQ.0) RETURN   ! NO ERRORS FOUND

c      WRITE (*,2850) KCMIN,KCMAX,NER
c 2850 FORMAT (3I7)
c      WRITE (*,2860) (KCOL(I),I=1,NER)
c 2860 FORMAT (20I7)
 

C
C IF THE FIRST PIXEL IS CLOSE TO THE BEGINNING THE LAST PIXEL IS CLOSE TO THE END OF THE LINE,
C STOP CORRECTIG AND LABEL ALL WRONG LONGITUDES AS UNDETERMINED (9999)
C

      IF (KCMIN.LT.30) THEN
             DO ICOL=1,KCMAX
                 VLON(ICOL)=9999.
             ENDDO
             GOTO 120
      ENDIF

      NC30=NCOL-30
      IF (KCMAX.GT.NC30) THEN
             DO ICOL=KCMIN,NCOL
                  VLON(ICOL)=9999.
             ENDDO
             GOTO 120 
      ENDIF
      
C
C DETERMINE LONGITUDE STEP FOR 4 PIXELS BEFORE AND 4 PIXELS AFTER THE BAD INTERVAL
C

      DS=0
      NS=0
      KP1=KCMIN-4
      KP2=KCMIN-1
      DO ICOL=KP1,KP2
          NS=NS+1
          DS=DS+DLON(ICOL)
      ENDDO
      DS1=DS/FLOAT(NS)

      DS=0
      NS=0
      KP1=KCMAX+1
      KP2=KCMAX+4
      DO ICOL=KP1,KP2
           NS=NS+1
           DS=DS+DLON(ICOL)
      ENDDO
      DS2=DS/FLOAT(NS)
      DSRD=ABS((DS1-DS2)/DS1)*100  ! RELATIVE DIFFERENCE OF TWO INTERVALS
c      WRITE (*,2870) DS1, DS2, DSRD
c 2870 FORMAT ('DS1, DS2, REL_DIFFERENCE(%): ',2F8.3,F7.2) 
      DSRD=ABS((DS1-DS2)/DS1)*100
      AVD1=(DS1+DS2)/2  ! AVERAGE LONGITUDE STEP

      DXLON=VLON(KCMAX+1)-VLON(KCMIN-1)
      KS=KCMAX+1-(KCMIN-1)
      AVD2=DXLON/FLOAT(KS)
c      WRITE (*,2880) AVD1,AVD2
c 2880 FORMAT ('AVD 1,2: ',2F8.3)

      KCMS=KCMIN-1
      ICC=0
      DO ICOL=KCMIN,KCMAX
          ICC=ICC+1
          VLON(ICOL)=VLON(KCMS)+AVD2*ICC
      ENDDO
C
C PRINT OUT 
C

  120 CONTINUE
      KC1=KCMIN-4
      KC2=KCMAX+4

c      WRITE (*,2900) ILIN, KC1,KC2
c 2900 FORMAT ('ILIN, KC1, KC2: ',3I6)
c      WRITE (*,2890) (VLON(ICOL),ICOL=KC1,KC2)
c 2890 FORMAT (15F9.3)

      RETURN
      END
